/* MMConstants.h */

#ifndef H_MMConstants_H
#define H_MMConstants_H

#include <CoreFoundation/CoreFoundation.h>
#include <ModuleManager/MMVersion.h>
#include <iso646.h>

#ifdef __cplusplus
	extern "C" {
#endif

#define kMMDontUpdate kCFBooleanFalse
#define kMMUpdate kCFBooleanTrue

#if 0
enum {
	kMMParamErr = -50,
	kMMCoreErr = -4960,
	kMMFnfErr = -43,
	kMMDupFNErr = -48,
	kMMDontCreateFolder = 0,
};
#endif

enum {
	kMMFileInfoStoreMinimal = 0x0,
	kMMFileInfoStorePOSIXPath = 0x0001,
	kMMFileInfoStoreHFSPath = 0x0002,
	kMMFileInfoStoreBookmarkData = 0x0004,
	kMMFileInfoStoreAll = kMMFileInfoStorePOSIXPath|kMMFileInfoStoreHFSPath|kMMFileInfoStoreBookmarkData,
};
typedef CFIndex MMFileInfoStorageFlags;

enum {
	kMMLibraryFlagsNone = 0x0000,
	kMMLibraryFlagPermitOverrides = 0x0001,
	kMMLibraryFlagSearchRecursively = 0x0002,
	kMMLibraryFlagTrackAliases = 0x0004,
	kMMLibraryFlagIsReserved = 0x0008,
};
typedef CFIndex MMLibraryFlags;

typedef CFPropertyListRef MMTypeRef;
typedef void * MMAnyTypeRef;
typedef CFStringRef MMUUIDRef;
typedef CFMutableDictionaryRef MMErrorRef;

/* ModuleManager keys and default values */
extern const CFStringRef kMMDocumentVersion;
extern const CFStringRef kMMKeyDefaultFolderName;
extern const CFStringRef kMMDefaultFolderName;
extern const CFStringRef kMMKeyModuleDocumentFileExtension;
extern const CFStringRef kMMKeyModuleDocumentPropertyListID;
extern const CFStringRef kMMKeyBundleModulesContainer;

/* TopLevel document keys. */
extern const CFStringRef kMMTopLevelKeyDisabledFolderSubstrings;
extern const CFStringRef kMMTopLevelKeyDocumentVersion;
extern const CFStringRef kMMTopLevelKeyExtensions;
extern const CFStringRef kMMTopLevelKeyFiles;
extern const CFStringRef kMMTopLevelKeyLibraries;
extern const CFStringRef kMMTopLevelKeyMap;
extern const CFStringRef kMMTopLevelKeyProperties;
extern const CFStringRef kMMTopLevelKeySearchConfigurations;
extern const CFStringRef kMMTopLevelKeySearchConfigurationLastSelected;

/* Library */
extern const CFStringRef kMMKindLibrary;
extern const CFStringRef kMMKeyLibraryIDs;

/* Library Containers */
extern const CFStringRef kMMLibraryDescriptionKeyProperties;
extern const CFStringRef kMMKeyFolderInfo;
extern const CFStringRef kMMKeyFlags;
extern const CFStringRef kMMKeyFiles;

/* Property Names */
extern const CFStringRef kMMLibraryKeyPropertyID;
extern const CFStringRef kMMKeyTitle;
extern const CFStringRef kMMKeyKind;
extern const CFStringRef kMMKeyParentID;
extern const CFStringRef kMMKeyOwners;
extern const CFStringRef kMMKeyUUID;
extern const CFStringRef kMMKeyBaseURIString;
extern const CFStringRef kMMKeyChildren;
extern const CFStringRef kMMKeyInherits;
extern const CFStringRef kMMKeyNotes;
extern const CFStringRef kMMKeyScript;
extern const CFStringRef kMMKeyWebsite;
extern const CFStringRef kMMKeyEnabled;

extern const CFStringRef kMMKindProperties;
extern const CFStringRef kMMKindFiles;
extern const CFStringRef kMMKindFileInfo;
extern const CFStringRef kMMKindFolderInfo;
extern const CFStringRef kMMKindFlags;

/* FileInfo */
extern const CFStringRef kMMFileInfoKeyAliasData;
extern const CFStringRef kMMFileInfoKeyBookmarkData;
extern const CFStringRef kMMFileInfoKeyHFSPath;
extern const CFStringRef kMMFileInfoKeyPOSIXPath;
extern const CFStringRef kMMFileInfoKeyURLString;
extern const CFStringRef kMMFileInfoKeyURLMapID;

/* Default Libraries */
extern const CFStringRef kMMUserLibraryDefaultTitle;
extern const MMUUIDRef  kMMUserLibraryID;
extern const CFStringRef kMMUserLibraryBaseURI;

extern const CFStringRef kMMLocalLibraryDefaultTitle;
extern const MMUUIDRef  kMMLocalLibraryID;
extern const CFStringRef kMMLocalLibraryBaseURI;

extern const CFStringRef kMMNetworkLibraryDefaultTitle;
extern const MMUUIDRef  kMMNetworkLibraryID;
extern const CFStringRef kMMNetworkLibraryBaseURI;

extern const CFStringRef kMMLibraryAutoIDPrefix;

/* Search Configurations */
extern const CFStringRef kMMKeySearchConfigurationLibraryIDs;
extern const CFStringRef kMMKindSearchConfiguration;

/* Default Search Configurations */
extern const MMUUIDRef kMMSearchConfigurationIDUser;
extern const CFStringRef kMMSearchConfigurationDefaultTitleUser;

extern const MMUUIDRef kMMSearchConfigurationIDLocal;
extern const CFStringRef kMMSearchConfigurationDefaultTitleLocal;

extern const MMUUIDRef kMMSearchConfigurationIDNetwork;
extern const CFStringRef kMMSearchConfigurationDefaultTitleNetwork;

/* Folder Name Substrings Disabled for Searching */
extern const CFStringRef kMMSubstring_Disabled;

/* Errors */
extern const CFStringRef kMMErrorDomainOSStatus;
extern const CFStringRef kMMErrorDomainPOSIX;

/* Common */
extern const CFStringRef kMMURLSchemeFile;
extern const CFStringRef kMMURLSchemeHTTP;
extern const CFStringRef kMMURLSchemeHTTPs;
extern const CFStringRef kMMURLSchemeFTP;
extern const CFStringRef kMMFileNameDSStore;

/* Document loading Options */
extern const CFStringRef kMMDocumentOptionInstallExamples;	/* CFBooleanRef */


#ifdef __cplusplus
}
#endif

#endif /*H_MMConstants_H*/
