/* MMServices.h */

#ifndef H_MMServices_H
#define H_MMServices_H

#include <CoreFoundation/CoreFoundation.h>
#include <CoreServices/CoreServices.h>
#include <ApplicationServices/ApplicationServices.h>

#include <ModuleManager/ModuleManager.h>
#include <ModuleManager/MMUtilities.h>

#ifdef __cplusplus
	extern "C" {
#endif

extern CFDataRef MMAliasDataCreateWithFSSpec( CFAllocatorRef theAllocator, const FSRef *theFSRef, MMErrorRef *outError );
extern CFDataRef MMAliasDataCreateWithFileURL( CFAllocatorRef theAllocator, CFURLRef theURL, MMErrorRef *outError );
extern CFURLRef MMAliasDataCopyURL( CFAllocatorRef theAllocator, CFDataRef theAliasData, MMErrorRef *outError );

extern OSStatus MMCreateDescWithCFBoolean( CFBooleanRef theBoolean, AEDesc *outDesc );
extern OSStatus MMCreateUTF8DescWithCFString( CFStringRef theString, AEDesc *outDesc );
extern OSStatus MMCreateFSRefDescWithFileURL( CFURLRef theURL, AEDesc *outDesc );
extern OSStatus MMCreateAliasDescWithFileURL( CFURLRef theURL, AEDesc *outDesc );
extern OSStatus MMCreateUTF8TextDescWithURL( CFURLRef theURL, AEDesc *outDesc );
extern OSStatus MMCreatePOSIXPathDescWithURL( CFURLRef theURL, AEDesc *outDesc );

#ifdef __cplusplus
}
#endif

#endif /*H_MMServices_H*/
